#include <stdint.h>
#include "params.h"
#include "crypto_hash_sha256.h"

extern void compress_v(int32_t t[PARAM_M], double v[PARAM_M]);

void random_oracle(unsigned char *c_bin,  double v[PARAM_M], const unsigned char *m, unsigned long long mlen)
{
  int32_t t[PARAM_M];
  unsigned long long i;
  unsigned char buf[PARAM_M+mlen];

  compress_v(t, v);
  
  for(i=0; i<PARAM_M; i++)
    buf[i] = t[i];
  for(i=0; i<mlen; i++)
    buf[i+PARAM_M] = m[i];

  crypto_hash_sha256(c_bin, buf, PARAM_M+mlen);
}


